'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _ensureTense2 = require('../library/ensure-tense');

var _ensureTense3 = _interopRequireDefault(_ensureTense2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (parsed, when, value) {
	var negated = when === 'never';

	var _ensureTense = (0, _ensureTense3.default)(parsed.body, value),
	    matches = _ensureTense.matches,
	    offending = _ensureTense.offending;

	var offenders = offending.map(function (item) {
		return [item.lemma, item.tense].join(' - ');
	}).join(',');

	return [negated ? !matches : matches, [`tense of body must`, negated ? `not` : null, `be ${value}. Verbs in other tenses: ${offenders}`].filter(Boolean).join(' ')];
};

module.exports = exports['default'];